var DesignSurface = function() {
  
  this.addEventListener = function(eventName, id, listener) {
      var success = true;
      if (!this.Event[eventName])
        success = false;
      else
        this.Event[eventName][id] = listener;
      return success;
    };
  
    this.removeEventListener = function(eventName, id) {
      delete this.Event[eventName][id];
    };
  
    this.fireEvent = function(eventName) {
      var ev   = this.Event[eventName],
          args = Array.prototype.slice.call(arguments);
      args.shift();
      for (id in ev) {
        ev[id].apply(this, args);
      }
  };
  
  this.Event = [];
  this.Event['AddPage'] = [];
  this.Event['DeletePage'] = [];
  this.Event['UpdatePage'] = [];
  this.Event['UpdatePageSortOrder'] = [];
  this.Event['AddFieldset'] = [];
  this.Event['DeleteFieldset'] = [];
  this.Event['UpdateFieldset'] = [];
  this.Event['UpdateFieldsetSortOrder'] = [];
  this.Event['AddField'] = [];
  this.Event['DeleteField'] = [];
  this.Event['UpdateField'] = [];
  this.Event['UpdateFieldSortOrder'] = [];
  this.Event['AddPrevalue'] = [];
  this.Event['DeletePrevalue'] = [];
  this.Event['SaveDesign'] = [];
  this.Event['ShowAddFieldDialog'] = [];
  this.Event['ShowUpdateFieldDialog'] = [];
  
  this.AddPage = function(Id, Name)
  {
  	this.fireEvent('AddPage', Id, Name);
  };
  
  this.DeletePage = function(Id)
  {
    	this.fireEvent('DeletePage', Id);
  };
  
  this.UpdatePage = function(Id, Name)
  {
      	this.fireEvent('UpdatePage', Id, Name);
  };
  
  this.UpdatePageSortOrder = function(Sortorder)
  {
        this.fireEvent('UpdatePageSortOrder', Sortorder);
  };
  
  this.AddFieldset = function(PageId, Id, Name)
  {
  	this.fireEvent('AddFieldset', PageId, Id, Name);
  };
  
  this.DeleteFieldset = function(Id)
  {
    	this.fireEvent('DeleteFieldset', Id);
  };
  
  this.UpdateFieldsetSortOrder = function(Id, Sortorder)
  {
      	this.fireEvent('UpdateFieldsetSortOrder', Id, Sortorder);
  };  
  
  this.UpdateFieldset = function(Id, Name)
  {
        	this.fireEvent('UpdateFieldset', Id, Name);
  }; 
  
  this.AddField = function(FieldsetId, Id, Name, Type, Mandatory, Regex)
  {
  	this.fireEvent('AddField', FieldsetId, Id, Name, Type, Mandatory, Regex);
  };
  
  this.DeleteField = function(Id)
  {
    	this.fireEvent('DeleteField', Id);
  };
  
  this.UpdateField = function(Id, Name, Type, Mandatory, Regex)
  {
      	this.fireEvent('UpdateField', Id, Name, Type, Mandatory, Regex);
  };   
  
  this.UpdateFieldSortOrder = function(Id, Sortorder)
  {
        	this.fireEvent('UpdateFieldSortOrder', Id, Sortorder);
  };

  this.SaveDesign = function(Guid, Design) 
  {
      this.fireEvent('SaveDesign', Guid, Design);
  };

  this.ShowAddFieldDialog = function() {
    this.fireEvent('ShowAddFieldDialog');
  };

  this.ShowUpdateFieldDialog = function() {
      this.fireEvent('ShowUpdateFieldDialog');
  };  
}





//myDesignSurface.addEventListener("AddPage", "addpage", function(id,name) {
//  //alert("Added page " + id + " name:" + name);
//});

//myDesignSurface.addEventListener("DeletePage", "deletepage", function(id) {
//  //alert("Deleted page " + id);
//});

//myDesignSurface.addEventListener("UpdatePage", "updatepage", function(id,name) {
//  //alert("Updated page " + id + " to: " + name);
//});

//myDesignSurface.addEventListener("UpdatePageSortOrder", "updatepagesortorder", function(sortorder) {
//  //alert("Updated page sortorder " + sortorder);
//});

//myDesignSurface.addEventListener("AddFieldset", "addfieldset", function(pageid,id,name) {
//  //alert("Added fieldset " + id + " name: " + name + " to page: " + pageid);
//});

//myDesignSurface.addEventListener("DeleteFieldset", "deletefieldset", function(id) {
//  //alert("Deleted fieldset " + id);
//});

//myDesignSurface.addEventListener("UpdateFieldset", "updatefieldset", function(id,name) {
//  //alert("Updated fieldset " + id + " to: " + name);
//});

//myDesignSurface.addEventListener("UpdateFieldsetSortOrder", "updatefieldsetsortorder", function(id,sortorder) {
//  //alert("Updated fieldset sortorder " + id + " : " + sortorder);
//});


//myDesignSurface.addEventListener("AddField", "addfield", function(fieldsetid,id,name,type,mandatory,regex) {
//  //alert("Added field " + id + " name:" + name + " type: " + type + " mandatory: " + mandatory + " regex: " + regex);
//});

//myDesignSurface.addEventListener("DeleteField", "deletefield", function(id) {
//  //alert("Deleted field " + id);
//});

//myDesignSurface.addEventListener("UpdateField", "updatefield", function(id,name,type,mandatory,regex) {
//  //alert("Updated field " + id + " to: name:" + name + " type: " + type + " mandatory: " + mandatory + " regex: " + regex);
//});


//myDesignSurface.addEventListener("UpdateFieldSortOrder", "updatefieldsortorder", function(id,sortorder) {
//  //alert("Updated field sortorder " + id + " : " + sortorder);
//});

//myDesignSurface.addEventListener("SaveDesign", "savedesign", function(guid,design) {
//    //alert("Save Design " + design);
//});


